<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Categorias;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Storage;

class CategoriasController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
        return Categorias::all();
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $uuid = md5(uniqid(rand(), true));
        $ext = $request->file("imagen")->extension();
        $name = $uuid.".".$ext;
        $uuid2 = md5(uniqid(rand(), true));
        $ext2 = $request->file("imagen_hover")->extension();
        $name2 = $uuid2.".".$ext2;
        if($request->file("imagen")->storeAs(/*"public/categorias/imagenes"*/env("IMG_SAVE_AS_CAT_URL"),$name) && $request->file("imagen_hover")->storeAs(/*"public/categorias/imagenes"*/env("IMG_SAVE_AS_CAT_URL"),$name2)){
            $response["code_upload"] = 200;
            $response["status"] = 200;

            $categoria = new Categorias();
            $categoria->nombre = $request->nombre;
            $categoria->url_imagen = env("IMG_SET_NAME_NEW_CAT").$name;
            $categoria->url_imagen_hover = env("IMG_SET_NAME_NEW_CAT").$name2;
            $categoria->status = $request->status;
            if($categoria->save()){
                $response["result"] = $categoria;
                $response["code_query"] = 200;
                $response["status"] = 200;
            }
            else{
                $response["code_query"] = 400;
                $response["status"] = 400;
                $response["msg"] = "No se guardaron los datos";
            }

        }else{
            $response["code_upload"] = 400;
            $response["status"] = 400;
            $response["msg"] = "Error al subir las imagenes";
        }

        return response()->json($response);
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $categoria = Categorias::find($id);
        $response["id"] = $id;
        $response["cat"] = $categoria;
        $response["request"] = $request->nombre;
        $categoria->nombre = $request->nombre;
        $categoria->status = $request->status;
        $flag1 = true;
        $flag2 = true;
        
        if($request->file("imagen")){//ver si hay una nueva imagen
            //hay que borrar la anterior y subir la nueva, tambien en la bd
            $img = explode("/",$categoria->url_imagen);
            $response["img"] = $img[3];
            Storage::delete(env("IMG_DELETE_CAT_IMG").$img[3]);
            $name = $this->generateName($request->file("imagen"));
            if(!$request->file("imagen")->storeAs(env("IMG_SAVE_AS_CAT_URL"),$name)){
                $flag1 = false;
                $response["code"] = 400;
                $response["msg"] = "Error al subir la imagen";
            }else{
                $categoria->url_imagen = env("IMG_SET_NAME_NEW_CAT").$name;
            }
        }
        if($request->file("imagen_hover")){//ver si hay una nueva imagen
            //hay que borrar la anterior y subir la nueva, tambien en la bd
            $img = explode("/",$categoria->url_imagen_hover);
            $response["img_hov"] = $img[3];
            Storage::delete(env("IMG_DELETE_CAT_IMG").$img[3]);
            $name = $this->generateName($request->file("imagen_hover"));
            if(!$request->file("imagen_hover")->storeAs(env("IMG_SAVE_AS_CAT_URL"),$name)){
                $flag2 = false;
                $response["code"] = 400;
                $response["msg"] = "Error al subir la imagen";
            }else{
                $categoria->url_imagen_hover = env("IMG_SET_NAME_NEW_CAT").$name;
            }
            /*$flag2 = $request->file("imagen_hover")->storeAs("public/categorias/imagenes",$name);
            }else{
                $flag2 = false;
            }*/
        }

        //if()

        if($flag1 && $flag2){
            //tienen que ser verdaderos los 2, sino, hubo problemas con las imagenes y no hay que continuar con el proceso de actualizacion
            if($categoria->save()){
                $response["code"] = 200;
                $response["categoria"] = $categoria;
            }else{
                $response["code"] = 400;
                $response["msg"] = "Error al actualizar la categoría";
            }

        }/*else{
            $response["code"] = 400;
            $response["msg"] = "Error al eliminar la imagen";
        }*/
        

        return $response;

    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }

    private function generateName($file){
        $uuid = md5(uniqid(rand(), true));
        $ext = $file->extension();
        $name = $uuid.".".$ext;
        return $name;
    }
    private function subirNuevaImagen($file){
        $name = $this->generateName($request->file("imagen"));
        return $file->storeAs(env("IMG_SAVE_AS_CAT_URL"),$name);
    }
}
