<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Producto;
use App\Spec;
use Illuminate\Support\Facades\DB;
class ProductosController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $productos = Producto::productos();
        return $productos;
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $name = $this->generateName($request->file("imagen"));
        $name2 = $this->generateName($request->file("imagen_specs"));
        if($request->file("imagen")->storeAs(/*"public/categorias/imagenes"*/env("IMG_SAVE_AS_PROD_URL"),$name) && $request->file("imagen_specs")->storeAs(/*"public/categorias/imagenes"*/env("IMG_SAVE_AS_SPECS_URL"),$name2)){
            $response["code_upload"] = 200;
            $response["status"] = 200;

            $producto = new Producto();
            $producto->nombre = $request->nombre;
            $producto->url_imagen = env("IMG_SET_NAME_NEW_PROD").$name;
            //$producto->url_imagen_hover = env("IMG_SET_NAME_NEW_CAT").$name2;
            $producto->status = $request->status;
            $producto->id_categoria = $request->categoria;
            $producto->id_tipo = $request->tipo;
            $producto->proceso = $request->proceso;
            $producto->descripcion = $request->descripcion;
            if($producto->save()){
                $response["result"] = $producto;
                $response["code_query"] = 200;
                $response["status"] = 200;
                $specs = new Spec();
                $specs->spec = $request->specs;
                $specs->url_imagen = env("IMG_SET_NAME_NEW_SPECS").$name2;
                $specs->id_producto = $producto->id;
                $specs->status = $request->statusSpecs;

                if($specs->save()){
                    $response["resultSpecs"] = $specs;
                    $response["code_query"] = 200;
                    $response["status"] = 200;
                    $response["producto"] = DB::table("productos")
        ->join("specs","productos.id","=","specs.id_producto")
        ->join("categorias","productos.id_categoria","=","categorias.id")
        ->join("tipos","productos.id_tipo","=","tipos.id")
        ->where("productos.id",$producto->id)
        ->select("productos.*","specs.id as specID","specs.spec","specs.status as statusSpec","specs.url_imagen as url_imagen_spec","categorias.nombre as categoria","tipos.nombre as tipo")
        ->get();
                }
            }
            else{
                $response["code_query"] = 400;
                $response["status"] = 400;
                $response["msg"] = "No se guardaron los datos";
            }

        }else{
            $response["code_upload"] = 400;
            $response["status"] = 400;
            $response["msg"] = "Error al subir las imagenes";
        }

        return $response;
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }

    private function generateName($file){
        $uuid = md5(uniqid(rand(), true));
        $ext = $file->extension();
        $name = $uuid.".".$ext;
        return $name;
    }
}
